/*******************************************************************
 * Xatm -- OCF, CID, TrueType scalable font support for X 
 *  By:  ͵ <y5t0964@students.chiba-u.ac.jp>
 */

/* util.c */

/* $Id: util.c,v 1.6 1999/03/22 08:36:50 elca Exp $ */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "Xatm.h"

/*#define dprintf(str) fprintf str */
#define dprintf(str) /* */

/* ʸʸΰ㤤̵뤹 strstr() */
char * strcasestr(char *haystack, const char *needle)
{
	char *haystackbuf;
	char *needlebuf;
	int i;
	char *ptr;
	char *ret;

	haystackbuf = strdup(haystack);
	needlebuf = strdup(needle);
	if(haystackbuf == NULL || needlebuf == NULL) {
		free(haystackbuf);
		free(needlebuf);
		return NULL;
	}

	/* change to lower case */
	for(i = 0; haystackbuf[i] != 0; i++) {
		haystackbuf[i] = (char)tolower(haystackbuf[i]);
	}
	for(i = 0; needlebuf[i] != 0; i++) {
		needlebuf[i] = (char)tolower(needlebuf[i]);
	}

	ptr = strstr(haystackbuf, needlebuf);

	if(ptr == NULL) {
		ret = NULL;
	} else {
		ret = (ptr - haystackbuf) + haystack;
	}

	dprintf((stdout, "hay %s->%s, need %s->%s, ret %d\n",
		 haystack, haystackbuf,
		 needle, needlebuf, ret));

	free(haystackbuf);
	free(needlebuf);

	return ret;
}

/****************************************************************
 * fonts.dir ǻꤷե̾ե̾
 *
 * "WadaLab-Mincho-0-8.atm" -> "WadaLab-Mincho-0-8"
 *
 * ̤ fontname ˳Ǽ롣餫ώʬΰݤƤ
 * ޥ MAXFONTFILENAMELEN Ȥɤ
 */
int xatm_get_fontname(char *filename, char *fontname)
{
	char fontname_buf[MAXFONTFILENAMELEN];
	int pos;

	strcpy(fontname_buf, filename);
	pos = strlen(fontname_buf) - strlen(XATM_EXT);
	if (pos <= 0) {
		return BadFontName;
	}
	fontname_buf[pos] = '\0';

	strcpy(fontname, fontname_buf);

	return Successful;
}

/* end */
